#include <iostream>
#include <cstdlib>
#include <iomanip>
using namespace std;

class seno {
	public:
		//Attributi
		int maxiter;
		double maxerr;
		//Metodi
		seno(int useriter);
		seno(int useriter,double usererr);
		double sen(double a);
		double esen(double a);
};

main() {
	double a;
	seno s = seno(20);
	seno s2 = seno(20,0.001);
	cout << "Inserisci un angolo in radianti\n" ;
	cin >> a;
	double sin = s.sen(a);
	double sin2 = s2.esen(a);
	cout.precision(16);
	cout << "seno(alfa) = " << sin << endl;
	cout << "eseno(alfa) = " << sin2 << endl;
}

//Costruttori
seno::seno(int useriter) {
	maxiter = useriter;
}
seno::seno(int useriter,double usererr) {
	maxiter = useriter;
	maxerr = usererr;
}

//Metodo di calcolo del seno
double seno::sen(double a) {
	double t=a,s=a;
	for (int i=1;i<maxiter;i++) {
		t=-t*a*a/((2*i+1)*2*i);
		s+=t;
	}
	return s;
}

//Metodo di calcolo del seno con max errore
double seno::esen(double a) {
	double t,tp=a,s=a,sp=a,err=1;
	for (int i=1; i<=maxiter && err>maxerr; i++) {
		t = -tp * ((a*a)/((2*i + 1)*2*i));
		s += t;
		if(sp>s) err = (sp-s)/sp;
		else err = (s-sp)/s;
		tp = t;
		sp = s;
	}
	return s;
}
